#ifndef _H_u_ietf_interfaces
#define _H_u_ietf_interfaces
/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2020, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *

*** Generated by yangdump-sdk

    User SIL header
    module ietf-interfaces
    revision 2014-05-08
    namespace urn:ietf:params:xml:ns:yang:ietf-interfaces
    organization IETF NETMOD (NETCONF Data Modeling Language) Working Group
    Created: 2020-03-05T01:12:07Z
    CLI parameters:
        format uh
        indent 4
        log-level debug3
        module ietf-interfaces
        output u_ietf-interfaces.h
        sil-edit2
        sil-get2
        unified true

 */

#include <xmlstring.h>

#include "agt.h"
#include "agt_cb.h"
#include "dlq.h"
#include "ncxtypes.h"
#include "op.h"
#include "rpc.h"
#include "ses.h"
#include "status.h"
#include "val.h"
#include "y_ietf-interfaces.h"

#ifdef __cplusplus
extern "C" {
#endif
/* Feature ietf-interfaces:arbitrary-names
 * Comment out to disable */
#define u_ietf_interfaces_F_arbitrary_names 1

/* Feature ietf-interfaces:pre-provisioning
 * Comment out to disable */
#define u_ietf_interfaces_F_pre_provisioning 1

/* Feature ietf-interfaces:if-mib
 * Comment out to disable */
#define u_ietf_interfaces_F_if_mib 1



/* list /interfaces/interface */
typedef struct y_ietf_interfaces_T_interfaces_interface_ {
    dlq_hdr_t qhdr;
    xmlChar *v_name;
    xmlChar *v_description;
    val_idref_t *v_type;
    boolean v_enabled;

#ifdef u_ietf_interfaces_F_if_mib
    xmlChar *v_link_up_down_trap_enable;
#endif /* u_ietf_interfaces_F_if_mib */
} y_ietf_interfaces_T_interfaces_interface;

/* container /interfaces */
typedef struct y_ietf_interfaces_T_interfaces_ {
    dlq_hdr_t v_interface;
} y_ietf_interfaces_T_interfaces;

/* leaf-list /interfaces-state/interface/higher-layer-if */
typedef struct y_ietf_interfaces_T_interfaces_state_interface_higher_layer_if_ {
    dlq_hdr_t qhdr;
    xmlChar *v_higher_layer_if;
} y_ietf_interfaces_T_interfaces_state_interface_higher_layer_if;

/* leaf-list /interfaces-state/interface/lower-layer-if */
typedef struct y_ietf_interfaces_T_interfaces_state_interface_lower_layer_if_ {
    dlq_hdr_t qhdr;
    xmlChar *v_lower_layer_if;
} y_ietf_interfaces_T_interfaces_state_interface_lower_layer_if;

/* container /interfaces-state/interface/statistics */
typedef struct y_ietf_interfaces_T_interfaces_state_interface_statistics_ {
    xmlChar *v_discontinuity_time;
    uint64 v_in_octets;
    uint64 v_in_unicast_pkts;
    uint64 v_in_broadcast_pkts;
    uint64 v_in_multicast_pkts;
    uint32 v_in_discards;
    uint32 v_in_errors;
    uint32 v_in_unknown_protos;
    uint64 v_out_octets;
    uint64 v_out_unicast_pkts;
    uint64 v_out_broadcast_pkts;
    uint64 v_out_multicast_pkts;
    uint32 v_out_discards;
    uint32 v_out_errors;
} y_ietf_interfaces_T_interfaces_state_interface_statistics;

/* list /interfaces-state/interface */
typedef struct y_ietf_interfaces_T_interfaces_state_interface_ {
    dlq_hdr_t qhdr;
    xmlChar *v_name;
    val_idref_t *v_type;

#ifdef u_ietf_interfaces_F_if_mib
    xmlChar *v_admin_status;
#endif /* u_ietf_interfaces_F_if_mib */
    xmlChar *v_oper_status;
    xmlChar *v_last_change;

#ifdef u_ietf_interfaces_F_if_mib
    int32 v_if_index;
#endif /* u_ietf_interfaces_F_if_mib */
    xmlChar *v_phys_address;
    dlq_hdr_t v_higher_layer_if;
    dlq_hdr_t v_lower_layer_if;
    uint64 v_speed;
    y_ietf_interfaces_T_interfaces_state_interface_statistics v_statistics;
} y_ietf_interfaces_T_interfaces_state_interface;

/* container /interfaces-state */
typedef struct y_ietf_interfaces_T_interfaces_state_ {
    dlq_hdr_t v_interface;
} y_ietf_interfaces_T_interfaces_state;


/********************************************************************
* FUNCTION u_ietf_interfaces_interfaces_interface_edit
*
* Edit database object callback
* Path: list /interfaces/interface
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*     k_ parameters are ancestor list key values.
*
* RETURNS:
*     error status
********************************************************************/
extern status_t u_ietf_interfaces_interfaces_interface_edit (
    ses_cb_t *scb,
    rpc_msg_t *msg,
    agt_cbtyp_t cbtyp,
    op_editop_t editop,
    val_value_t *newval,
    val_value_t *curval,
    const xmlChar *k_interfaces_interface_name);


/********************************************************************
* FUNCTION u_ietf_interfaces_interfaces_edit
*
* Edit database object callback
* Path: container /interfaces
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
extern status_t u_ietf_interfaces_interfaces_edit (
    ses_cb_t *scb,
    rpc_msg_t *msg,
    agt_cbtyp_t cbtyp,
    op_editop_t editop,
    val_value_t *newval,
    val_value_t *curval);


/********************************************************************
* FUNCTION u_ietf_interfaces_interfaces_state_interface_statistics_get
*
* Get database object callback for container statistics
* Path: container /interfaces-state/interface/statistics
* Fill in 'get2cb' response fields
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
extern status_t u_ietf_interfaces_interfaces_state_interface_statistics_get (
    getcb_get2_t *get2cb,
    const xmlChar *k_interfaces_state_interface_name);


/********************************************************************
* FUNCTION u_ietf_interfaces_interfaces_state_interface_get
*
* Get database object callback for list interface
* Path: list /interfaces-state/interface
* Fill in 'get2cb' response fields
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
extern status_t u_ietf_interfaces_interfaces_state_interface_get (
    getcb_get2_t *get2cb,
    const xmlChar *k_interfaces_state_interface_name,
    boolean name_fixed,
    boolean name_present);


/********************************************************************
* FUNCTION u_ietf_interfaces_interfaces_state_get
*
* Get database object callback for container interfaces-state
* Path: container /interfaces-state
* Fill in 'get2cb' response fields
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
extern status_t u_ietf_interfaces_interfaces_state_get (
    getcb_get2_t *get2cb);


/********************************************************************
* FUNCTION u_ietf_interfaces_init
*
* initialize the ietf-interfaces server instrumentation library
*
* INPUTS:
*    modname == requested module name
*    revision == requested version (NULL for any)
*
* RETURNS:
*     error status
********************************************************************/
extern status_t
    u_ietf_interfaces_init (const xmlChar *modname,
                            const xmlChar *revision);


/********************************************************************
* FUNCTION u_ietf_interfaces_init2
*
* SIL init phase 2: non-config data structures
* Called after running config is loaded
*
* RETURNS:
*     error status
********************************************************************/
extern status_t u_ietf_interfaces_init2 (void);


/********************************************************************
* FUNCTION u_ietf_interfaces_cleanup
*    cleanup the server instrumentation library
*
********************************************************************/
extern void u_ietf_interfaces_cleanup (void);


#ifdef __cplusplus
} /* end extern 'C' */
#endif

#endif
